<?php
/*
Plugin Name: Show Active Category (while browsing a post)
Plugin URI: http://www.screenshine.net/blog/1474_wordpress-plugin-show-active-category
Description: When browsing a single page, this plugin adds the CSS class "active_category" to all categories the active post belongs to.
Version: 0.1
Author: Dirk Jaster
Author URI: http://www.freshheit.de/
Author Email: dirk@freshheit.de
*/
/*  Copyright 2008 Dirk Jaster  (email: dirk@freshheit.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function show_active_category($text) {

	global $post;

	if( is_single() ) {

		$categories = wp_get_post_categories($post->ID);

		foreach( $categories as $catid ) {
			$cat = get_category($catid);
			if(preg_match('#>' . $cat->name . '</a>#', $text)) {
				$text = str_replace('>' . $cat->name . '</a>', ' class="active_category">' . $cat->name . '</a>', $text);
			}
		}

	}

	return $text;

}

add_filter('wp_list_categories', 'show_active_category');

?>